package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.dto.scale.NewResultDto;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.DimensionOrgEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;
import com.rf.psychological.scale.dao.model.WarnEntity;
import com.rf.psychological.scale.scaleresult.ScaleConstant;
import com.rf.psychological.scale.service.DimensionOrgService;
import com.rf.psychological.utils.Constant;
import org.springframework.beans.BeanUtils;
import org.springframework.lang.Nullable;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.*;
import java.util.stream.Collectors;

import static com.rf.psychological.scale.resultBusiness.scaleResult.SCSQScale.createWarnEntry;

/**
 * @author zsy
 * @description:纽芬兰纪念大学幸福度量表
 * @date 2021/7/20 15:55
 */
public class MUNSHScale extends BaseScale{

    public MUNSHScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        /*// 自定义路径使用
        ScaleUtil.getScaleDll("MUNSHScale.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.MUNSHScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //总的幸福度得分
        int score = 0;
        //PA
        int PAscore = 0;
        //NA
        int NAscore = 0;
        //PE
        int PEscore = 0;
        //NE
        int NEscore = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (i == 0 || i == 1 || i == 2 || i == 3 || i == 9){
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        PAscore += 1;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        PAscore += 2;
                    }
                }else if (i >= 4 && i <= 8){
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        NAscore += 1;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        NAscore += 2;
                    }
                }else if (i == 11 || i == 13 || i == 14 || i == 18 || i == 20 || i == 22 || i == 23){
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        PEscore += 1;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        PEscore += 2;
                    }
                }else {
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        NEscore += 1;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        NEscore += 2;
                    }
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")) {
                if (i == 0 || i == 1 || i == 2 || i == 3 || i == 9){
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        PAscore += 2;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        PAscore += 1;
                    }
                }else if (i >= 4 && i <= 8){
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        NAscore += 2;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        NAscore += 1;
                    }
                }else if (i == 11 || i == 13 || i == 14 || i == 18 || i == 20 || i == 22 || i == 23){
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        PEscore += 2;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        PEscore += 1;
                    }
                }else {
                    if (jsonObject1.getString("checkItems").equals("不知道")) {
                        NEscore += 2;
                    } else if (jsonObject1.getString("checkItems").equals("是")) {
                        NEscore += 1;
                    }
                }
            }
        }

        score = PAscore - NAscore + PEscore - NEscore;
        Map<String,Double> dimensionOrg = new HashMap<>();

        DecimalFormat df = new DecimalFormat("######0.00");

        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String, String>> resultMapList = new ArrayList<>();
        //新版本数据格式
        Map<String, Object> newResult = new LinkedHashMap<>();

        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        //计算每个维度得分dimensionEntities
        double[] dimensionScore = {PAscore,NAscore,PEscore,NEscore};

        //将量表总维度根据维度名称进行分组
        Map<String, List<ScaleMarksEntity>> scaleMarksMap = scaleMarksEntities.stream().collect(Collectors.groupingBy(ScaleMarksEntity::getName));
        //返回值以及存数据库格式
        List<NewResultDto> newResultDtos = new ArrayList<>();
        resultMap0.put("总分", df.format(score));
        resultJson.put("总分", df.format(score));
        dimensionOrg.put("8af178857b94d581017b94f7e01219f0", (double) PAscore);
        dimensionOrg.put("8af178857b94d581017b94f7e06619f1", (double) NAscore);
        dimensionOrg.put("8af178857b94d581017b94f7e0bb19f2", (double) PEscore);
        dimensionOrg.put("8af178857b94d581017b94f7e10f19f3", (double) NEscore);
        resultJson.put("dimensionScoreMap",dimensionOrg);
        BigDecimal scoreDecimal = new BigDecimal(df.format(score));
        //如果没有总分这一栏，需要手动赋值返回
        List<ScaleMarksEntity> totalScore = scaleMarksMap.get("总分");
        List<ScaleMarksEntity> totalScores = scaleMarksMap.get("无");
        if (totalScore == null) {
            if (totalScores == null){
                newResultDtos.add(new NewResultDto("总分", df.format(score), "无", "无",
                        "无", "无", "无", "无", "是"));
            }else {
                for (ScaleMarksEntity tempTotalScore : totalScores) {
                    BigDecimal scoreStart = new BigDecimal(tempTotalScore.getScoreStart());
                    BigDecimal scoreEnd = new BigDecimal(tempTotalScore.getScoreEnd());
                    if (scoreDecimal.compareTo(scoreEnd) <= 0 && scoreDecimal.compareTo(scoreStart) >= 0) {
                        newResultDtos.add(new NewResultDto("总分", df.format(score), tempTotalScore.getSymptom(), tempTotalScore.getImprovementSuggestions(),
                                tempTotalScore.getFlag(), tempTotalScore.getReference(), tempTotalScore.getNameExplain(), tempTotalScore.getSuggestion(), tempTotalScore.getIsTotalScoreExplain()));
                        resultMap0.put("总分解释", tempTotalScore.getSymptom());
                        resultMap0.put("总分说明", tempTotalScore.getImprovementSuggestions());
                    }
                }
            }
        } else {
            for (ScaleMarksEntity tempTotalScore : totalScore) {
                BigDecimal scoreStart = new BigDecimal(tempTotalScore.getScoreStart());
                BigDecimal scoreEnd = new BigDecimal(tempTotalScore.getScoreEnd());
                if (scoreDecimal.compareTo(scoreEnd) <= 0 && scoreDecimal.compareTo(scoreStart) >= 0) {
                    newResultDtos.add(new NewResultDto("总分", df.format(score), tempTotalScore.getSymptom(), tempTotalScore.getImprovementSuggestions(),
                            tempTotalScore.getFlag(), tempTotalScore.getReference(), tempTotalScore.getNameExplain(), tempTotalScore.getSuggestion(), tempTotalScore.getIsTotalScoreExplain()));
                    resultMap0.put("总分解释", tempTotalScore.getSymptom());
                    resultMap0.put("总分说明", tempTotalScore.getImprovementSuggestions());
                }
            }
        }


        JSONObject iconInfo = new JSONObject();
        //雷达图需要的维度以及最大值
        List<Map<String, Object>> indicator = new LinkedList<>();
        //雷达图所需要的常模参考值
        LinkedList<String> reference = new LinkedList<>();
        //雷达图需要的分数
        LinkedList<String> scoreList = new LinkedList<>();
        //计算维度所在评分区间
        commonComputeDimensionScore(df, resultMap0, resultJson, dimensionEntities, dimensionScore, scaleMarksMap, newResultDtos, indicator, reference, scoreList);
        //需要图表展示的
        iconInfo.put("indicator", indicator);
        //判断是否有常模参考值，即reference的内容如果全为0，则不进行返回
        if (!reference.stream().allMatch("0"::equals)) {
            iconInfo.put("reference", reference);
        }
        iconInfo.put("scoreList", scoreList);
        if (indicator.size() == 0 && reference.size() == 0) {
            newResult.put("iconInfo", "");
        } else {
            newResult.put("iconInfo", iconInfo);
        }
        newResult.put("result", newResultDtos);
        resultMapList.add(resultMap0);


        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("resultJson", resultJson);
        returnJson.put(ScaleConstant.ResultEnum.RESULT_NEW_FIELD.getKeyword(), newResult);

        return returnJson;


        /*//得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总的幸福度得分", String.valueOf(score));
        resultJson.put("总的幸福度得分", String.valueOf(score));

        resultMap.put("正性情感（PA）", String.valueOf(PAscore));
        resultJson.put("正性情感（PA）", String.valueOf(PAscore));
        resultMap.put("负性情感(NA)", String.valueOf(NAscore));
        resultJson.put("负性情感(NA)", String.valueOf(NAscore));
        resultMap.put("正性体验（PE）", String.valueOf(PEscore));
        resultJson.put("正性体验（PE）", String.valueOf(PEscore));
        resultMap.put("负性体验（NE）", String.valueOf(NEscore));
        resultJson.put("负性体验（NE）", String.valueOf(NEscore));
        dimensionOrg.put("8af178857b94d581017b94f7e01219f0", (double) PAscore);
        dimensionOrg.put("8af178857b94d581017b94f7e06619f1", (double) NAscore);
        dimensionOrg.put("8af178857b94d581017b94f7e0bb19f2", (double) PEscore);
        dimensionOrg.put("8af178857b94d581017b94f7e10f19f3", (double) NEscore);
        resultJson.put("dimensionScoreMap",dimensionOrg);
        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_MUNSH);
        returnJson.put("resultJson",resultJson);

        return returnJson;*/
    }

    /**
     * 通用计算量表所有维度分数，以及其维度所在分数段症状等
     *
     * @param df                用来设置小数位数，例如保留两位小数DecimalFormat df = new DecimalFormat("######0.00");
     * @param resultMap         用来向数据库存
     * @param resultJson        WebScaleResultController传递过来的评分规则等相关参数
     * @param dimensionEntities 量表维度list信息
     * @param dimensionScore    量表维度分数，需要和量表维度list对应
     * @param scaleMarksMap     评分规则的map
     * @param newResultDtos     各个维度的结论，等级解释等list
     * @param indicator         雷达图需要的维度以及最大值
     * @param reference         雷达图所需要的常模参考值
     * @param scoreList         雷达图需要的分数
     */
    public static void commonComputeDimensionScore(@Nullable DecimalFormat df, Map<String, String> resultMap, JSONObject resultJson, List<DimensionEntity> dimensionEntities, double[] dimensionScore, Map<String, List<ScaleMarksEntity>> scaleMarksMap, List<NewResultDto> newResultDtos, List<Map<String, Object>> indicator, List<String> reference, List<String> scoreList) {
        if (df == null) {
            df = new DecimalFormat("######0.00");
        }
        for (int y = 0; y < dimensionEntities.size(); y++) {
            Map<String, Object> indicatorMap = new HashMap<>();
            DimensionEntity dimensionEntity = dimensionEntities.get(y);
            NewResultDto newResultDto1 = new NewResultDto();
            //存放该维度总分
            resultMap.put(dimensionEntity.getName() + "得分", df.format(dimensionScore[y]));
            resultJson.put(dimensionEntity.getName() + "得分", df.format(dimensionScore[y]));
            newResultDto1.setScore(df.format(dimensionScore[y]));
            newResultDtos.add(newResultDto1);
            BigDecimal dimensionScoreDecimal = new BigDecimal(df.format(dimensionScore[y]));
            //获取当前维度的评分规则
            List<ScaleMarksEntity> scaleMarksEntities1 = scaleMarksMap.get(dimensionEntity.getName());
            if (scaleMarksEntities1 != null) {
                //循环遍历判断得分在哪个区间
                for (ScaleMarksEntity scaleMarksEntity : scaleMarksEntities1) {
                    BigDecimal decimalScoreEnd = new BigDecimal(scaleMarksEntity.getScoreEnd());
                    BigDecimal decimalScoreStart = new BigDecimal(scaleMarksEntity.getScoreStart());
                    if (dimensionScoreDecimal.compareTo(decimalScoreEnd) <= 0 && dimensionScoreDecimal.compareTo(decimalScoreStart) >= 0) {
                        putDimResult(resultMap, resultJson, dimensionEntity.getName(), newResultDto1, scaleMarksEntity);
                        //需要进行图表展示的维度放入map
                        if ("1".equals(dimensionEntity.getIsIconFlag())) {
                            indicatorMap.put("text", dimensionEntity.getName());
                            //将当前维度按照分数的结尾值来进行排序scaleMarksEntities1
                            List<ScaleMarksEntity> collect = scaleMarksEntities1.stream().sorted(Comparator.comparing(ScaleMarksEntity::getScoreEnd, Comparator.comparingInt(Integer::parseInt))
                                    .reversed()).collect(Collectors.toList());
                            //排序完成后第一个的scoreEnd最大，也就是该维度最大的
                            indicatorMap.put("max", collect.get(0).getScoreEnd());
                            indicator.add(indicatorMap);
                            if ("无".equals(scaleMarksEntity.getReference()) || "无".equals(scaleMarksEntity.getStandardDeviation())) {
                                //常模参考值设为0
                                reference.add("0");
                            } else {
                                reference.add(scaleMarksEntity.getReference());
                            }
                            scoreList.add(String.valueOf(dimensionScore[y]));
                        }
                    }
                }
            } else {
                //如果分数规则表中无维度，而维度表中有相应维度，则只显示维度分数
                newResultDto1.setFlag("无");
                newResultDto1.setImprovementSuggestions("无");
                newResultDto1.setName(dimensionEntity.getName());
                newResultDto1.setReference("无");
                newResultDto1.setNameExplain("无");
                newResultDto1.setSuggestion("无");
                newResultDto1.setIsTotalScoreExplain("否");
                newResultDto1.setSymptom("无");
            }
        }
    }

    private static void putDimResult(Map<String, String> resultMap0, JSONObject resultJson, String dimensionName, NewResultDto newResultDto1, ScaleMarksEntity scaleMarksEntity) {
        //resultMap0.put(dimensionName + "常模参考值", scaleMarksEntity.getReference());
        resultMap0.put(dimensionName + "解释", scaleMarksEntity.getSymptom());
        resultJson.put(dimensionName + "解释", scaleMarksEntity.getSymptom());
        resultMap0.put(dimensionName + "解读", scaleMarksEntity.getNameExplain());
        resultJson.put(dimensionName + "解读", scaleMarksEntity.getNameExplain());
        resultMap0.put(dimensionName + "说明", scaleMarksEntity.getImprovementSuggestions());
        resultJson.put(dimensionName + "说明", scaleMarksEntity.getImprovementSuggestions());
        resultMap0.put(dimensionName + "建议", scaleMarksEntity.getSuggestion());
        resultJson.put(dimensionName + "建议", scaleMarksEntity.getSuggestion());
        BeanUtils.copyProperties(scaleMarksEntity, newResultDto1);
    }

}
